require 'minitest/autorun'
require 'nummax'

class NumMaxTest < Minitest::Test
   
  def test_geti
    file = File.new("#{Dir.pwd}/test/test_files/text")
    
    assert_equal(42, file.geti)
    assert_equal("V", file.getc)
    assert_equal(1742, file.geti)
    assert_equal(4, file.geti)
    assert_equal(8, file.geti)
    assert_equal(1936, file.geti)
    file.getc
    file.getc
    assert_equal(937, file.geti)
    
    file.close
  end  
  
  def test_each_int
    file = File.new("#{Dir.pwd}/test/test_files/text")
    result = [42, 1742, 4, 8, 1936, 1937, 1958, 98, 20, 1954, 1955, 1958, 76]
    numbers = []
    file.each_int { |n| numbers << n }
    
    assert_equal(result, numbers)
    assert_equal(nil, file.geti)
    
    file.close
  end

  def test_nummax_text
    file = File.new("#{Dir.pwd}/test/test_files/text")
    result = [98, 1742, 1936, 1937, 1954, 1955, 1958]
    
    assert_equal(result, NumMax.run(file, "7"))
    assert_raises { NumMax.run(STDIN, 12) }
    assert_raises { NumMax.run(file, "12num") }
    assert_raises { NumMax.run(file, "0") }
    
    file.close
  end
  
  def test_nummax_number
    file = File.new("#{Dir.pwd}/test/test_files/number")
    result = [999991, 999992, 999993, 999994]

    assert_equal(result, NumMax.run(file, 4))
    
    file.pos = 0
    assert_equal(56, NumMax.run(file, 100000).size)
    
    file.close
  end
  
  def test_terminal
    command = "cat #{Dir.pwd}/test/test_files/number | #{Dir.pwd}/bin/nummax 3"
    result = "999992\n999993\n999994\n"
    assert_equal(`#{command}`, result)
  end
  
end
